Rapture = LibStub("AceAddon-3.0"):NewAddon("Rapture", "AceConsole-3.0", "AceEvent-3.0")
RaptureGUI = LibStub("AceGUI-3.0")
RaptureBAR = LibStub("LibCandyBar-3.0"):New("Interface\\AddOns\\IngelasRapture\\media\\smooth.tga", 200, 19)

local defaults = {
    profile = {
		scale = 1.0,
		xpos = 0,
		ypos = 0,
		colorr = 0, 
		colorg = 0.5, 
		colorb = 1, 
		colora = 1,
    },
}

local options = {
  type = "group",
  childGroups = "tab",
  args = {
		info = {
		  name = "Info",
		  desc = "Shows info about the addon",
		  type = 'execute',
		  func = function()
			Rapture:Print("This addon shows a neat bar too see how long cooldown is left on your rapture ability.")
		  end,
		},
		test = {
		  name = "Test",
		  desc = "Test rapture cooldown bar",
		  type = 'execute',
		  func = function()
			RaptureBAR:SetScale(Rapture.db.profile.scale)
			RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
			RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
			RaptureBAR:SetLabel("Rapture cooldown")
			RaptureBAR:SetDuration(12)
			RaptureBAR:Start()
		  end,
		},
	bar = {
      type = "group",
      name = "Bar options",
      args = {
	    barposdesc = {
		  order = 1,
          type = "description",
          name = "Bar positioning\n",
          cmdHidden = true
        },
		xpos = {
		  order = 3,
          name = "X",
          desc = "Change horizontal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.xpos end,
          set = function(info, x) 
		  Rapture.db.profile.xpos = x
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		},
		ypos = {
		  order = 6,
          name = "Y",
          desc = "Change veritcal position",
          type = 'range',
          min = -500,
          max = 500,
          step = 1,
          get = function(info) return Rapture.db.profile.ypos end,
          set = function(info, y) 
		  Rapture.db.profile.ypos = y
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		  },
		 nudgeright = {
		  order = 4,
          name = "Right",
          desc = "Nudge right once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.xpos end,
          func = function() 
		  Rapture.db.profile.xpos = Rapture.db.profile.xpos + 1
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgeleft = {
		  order = 2,
          name = "Left",
          desc = "Nudge left once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.xpos end,
          func = function() 
		  Rapture.db.profile.xpos = Rapture.db.profile.xpos - 1
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgeup = {
		  order = 5,
          name = "Up",
          desc = "Nudge up once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.ypos end,
          func = function() 
		  Rapture.db.profile.ypos = Rapture.db.profile.ypos + 1
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		 },
		 nudgedown = {
		  order = 7,
          name = "Down",
          desc = "Nudge down once",
          type = 'execute',
		  get = function(info) return Rapture.db.profile.ypos end,
          func = function() 
		  Rapture.db.profile.ypos = Rapture.db.profile.ypos - 1
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		 },
		scaledesc = {
		  order = 9,
          type = "description",
          name = "\n\nScale\n",
          cmdHidden = true
        },
		scale = {
		  order = 10,
          name = "Scale",
          desc = "Set scale",
          type = 'range',
          min = 0.5,
          max = 2,
          step = 0.1,
          get = function(info) return Rapture.db.profile.scale end,
          set = function(info, s) 
		  Rapture.db.profile.scale = s
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		},
	  },
	},
	colors = {
      type = "group",
      name = "Colors",
      args = {
	  	colordesc = {
		  order = 1,
          type = "description",
          name = "Color changer\n",
          cmdHidden = true
        },
		color = {
		  order = 2,
          name = "Bar color",
          desc = "Set color",
          type = 'color',
		  hasAlpha = true,
          get = function(info) return Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora end,
          set = function(info, r, g, b, a)
		  Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora = r, g, b, a
		  RaptureBAR:SetScale(Rapture.db.profile.scale)
		  RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		  RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		  RaptureBAR:SetLabel("TEST BAR")
		  RaptureBAR:SetDuration(20)
		  RaptureBAR:Start()
		  end,
		},
	  },
	},
	profiles = {
      type = "group",
      name = "Profiles",
      args = {
	  	profiledesc = {
		  order = 1,
          type = "description",
          name = "Nothing here yet, maybe for next release!",
          cmdHidden = true
        },
	  },
	},
  },
}

function Rapture:OnInitialize()
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Rapture", "Rapture")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Rapture", options, {"rapture", "rap", "Rapture", "Rap"})
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Rapture", options)
    self.db = LibStub("AceDB-3.0"):New("RaptureDB", defaults, "Default")
end

function Rapture:OnEnable()
	self:Print("Rapture Loaded")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function Rapture:SPELL_ENERGIZE(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, auraType, amount)
	local player_name = UnitName("player")
	if spellName == "Rapture" and destName == player_name and sourceName == player_name and spellId == 47755 then
		RaptureBAR:SetScale(Rapture.db.profile.scale)
		RaptureBAR:SetPoint("CENTER", UIParent,"CENTER", Rapture.db.profile.xpos, Rapture.db.profile.ypos)
		RaptureBAR:SetColor(Rapture.db.profile.colorr, Rapture.db.profile.colorg, Rapture.db.profile.colorb, Rapture.db.profile.colora)
		RaptureBAR:SetLabel("Rapture cooldown")
		RaptureBAR:SetDuration(12)
		RaptureBAR:Start()
	end
end

function Rapture:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	local func = self[event]
	if (func) then
		func(self, timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, amount, spellID, ...)
	end
end